/////////////////////////////////////////////////////////////////////////////
// Name:        OSCWindow.cpp
// Purpose:     
// Author:      jrg piringer
// Modified by: 
// Created:     04/05/2006 23:28:28
// RCS-ID:      
// Copyright:   
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#if defined(__GNUG__) && !defined(NO_GCC_PRAGMA)
#pragma implementation "OSCWindow.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"


#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "OSCWindow.h"
#include <math.h>
#include <wx/filename.h>
#include <wx/regex.h>

/*!
 * MyDialog type definition
 */

IMPLEMENT_DYNAMIC_CLASS( OSCWindow, wxFrame )

/*!
 * MyDialog event table definition
 */

BEGIN_EVENT_TABLE( OSCWindow, wxFrame )
	EVT_MENU(wxID_ABOUT, OSCWindow::OnAbout)
	EVT_MENU(wxID_EXIT, OSCWindow::OnQuit)
	EVT_MENU(wxID_PREFERENCES, OSCWindow::OnPreferences)

	EVT_BUTTON(ID_CHUCK_EXEC, OSCWindow::OnExecChuck)
	EVT_TEXT_ENTER(ID_CHUCK_FILE, OSCWindow::OnExecChuck)
    // file
    EVT_MENU (wxID_OPEN,             OSCWindow::OnFileOpen)
    EVT_MENU (wxID_SAVE,             OSCWindow::OnFileSave)
    EVT_MENU (wxID_SAVEAS,           OSCWindow::OnFileSaveAs)
    EVT_MENU (wxID_CLOSE,            OSCWindow::OnFileClose)
    // properties
    EVT_MENU (myID_PROPERTIES,       OSCWindow::OnProperties)
    // print and exit
    EVT_MENU (wxID_PRINT_SETUP,      OSCWindow::OnPrintSetup)
    EVT_MENU (wxID_PREVIEW,          OSCWindow::OnPrintPreview)
    EVT_MENU (wxID_PRINT,            OSCWindow::OnPrint)
    //EVT_MENU (wxID_EXIT,             OSCWindow::OnExit)
    // edit
    EVT_MENU (wxID_CLEAR,            OSCWindow::OnEdit)
    EVT_MENU (wxID_CUT,              OSCWindow::OnEdit)
    EVT_MENU (wxID_COPY,             OSCWindow::OnEdit)
    EVT_MENU (wxID_PASTE,            OSCWindow::OnEdit)
    EVT_MENU (myID_INDENTINC,        OSCWindow::OnEdit)
    EVT_MENU (myID_INDENTRED,        OSCWindow::OnEdit)
    EVT_MENU (wxID_SELECTALL,        OSCWindow::OnEdit)
    EVT_MENU (myID_SELECTLINE,       OSCWindow::OnEdit)
    EVT_MENU (wxID_REDO,             OSCWindow::OnEdit)
    EVT_MENU (wxID_UNDO,             OSCWindow::OnEdit)
    // find
    EVT_MENU (wxID_FIND,             OSCWindow::OnEdit)
    EVT_MENU (myID_FINDNEXT,         OSCWindow::OnEdit)
    EVT_MENU (myID_REPLACE,          OSCWindow::OnEdit)
    EVT_MENU (myID_REPLACENEXT,      OSCWindow::OnEdit)
    EVT_MENU (myID_BRACEMATCH,       OSCWindow::OnEdit)
    EVT_MENU (myID_GOTO,             OSCWindow::OnEdit)
    // view
    EVT_MENU_RANGE (myID_HILIGHTFIRST, myID_HILIGHTLAST,
                                     OSCWindow::OnEdit)
    EVT_MENU (myID_DISPLAYEOL,       OSCWindow::OnEdit)
    EVT_MENU (myID_INDENTGUIDE,      OSCWindow::OnEdit)
    EVT_MENU (myID_LINENUMBER,       OSCWindow::OnEdit)
    EVT_MENU (myID_LONGLINEON,       OSCWindow::OnEdit)
    EVT_MENU (myID_WHITESPACE,       OSCWindow::OnEdit)
    EVT_MENU (myID_FOLDTOGGLE,       OSCWindow::OnEdit)
    EVT_MENU (myID_OVERTYPE,         OSCWindow::OnEdit)
    EVT_MENU (myID_READONLY,         OSCWindow::OnEdit)
    EVT_MENU (myID_WRAPMODEON,       OSCWindow::OnEdit)
    // extra
    EVT_MENU (myID_CHANGELOWER,      OSCWindow::OnEdit)
    EVT_MENU (myID_CHANGEUPPER,      OSCWindow::OnEdit)
    EVT_MENU (myID_CONVERTCR,        OSCWindow::OnEdit)
    EVT_MENU (myID_CONVERTCRLF,      OSCWindow::OnEdit)
    EVT_MENU (myID_CONVERTLF,        OSCWindow::OnEdit)
    EVT_MENU (myID_CHARSETANSI,      OSCWindow::OnEdit)
    EVT_MENU (myID_CHARSETMAC,       OSCWindow::OnEdit)
    
    EVT_BUTTON(ID_CLOSE_CONTROL, OSCWindow::OnCloseControl)

	EVT_SLIDER(ID_SLIDER1, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+1, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+2, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+3, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+4, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+5, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+6, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+7, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+8, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+9, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+10, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+11, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+12, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+13, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+14, OSCWindow::OnSlider)
	EVT_SLIDER(ID_SLIDER1+15, OSCWindow::OnSlider)

	EVT_BUTTON(ID_BUTTON1, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+1, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+2, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+3, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+4, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+5, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+6, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+7, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+8, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+9, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+10, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+11, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+12, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+13, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+14, OSCWindow::OnButton)
	EVT_BUTTON(ID_BUTTON1+15, OSCWindow::OnButton)

	EVT_TOGGLEBUTTON(ID_TOGGLE1, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+1, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+2, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+3, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+4, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+5, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+6, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+7, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+8, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+9, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+10, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+11, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+12, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+13, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+14, OSCWindow::OnToggle)
	EVT_TOGGLEBUTTON(ID_TOGGLE1+15, OSCWindow::OnToggle)

	EVT_XYPAD(ID_XYPAD1, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+1, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+2, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+3, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+4, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+5, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+6, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+7, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+8, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+9, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+10, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+11, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+12, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+13, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+14, OSCWindow::OnXYPad)
	EVT_XYPAD(ID_XYPAD1+15, OSCWindow::OnXYPad)
END_EVENT_TABLE()

#define ADDRESS "127.0.0.1"
#define PORT 7000
#define SLIDERINIT 2
#define BUTTONINIT 2
#define TOGGLEINIT 2
#define XYPADINIT 2

SET_STRING_I(OSCWindow, osc_adress, "General", "OSC", "network adress", ADDRESS)
SET_LONG_I(OSCWindow, osc_port, "General", "OSC", "network port", PORT)
SET_STRING_I(OSCWindow, chuck_path, "General", "OSC", "chuck path", "")
SET_STRING_I(OSCWindow, last_chuck_file, "General", "OSC", "last chuck file", "")

//! global print data, to remember settings during the session
wxPrintData *g_printData = (wxPrintData*) NULL;
wxPageSetupData *g_pageSetupData = (wxPageSetupData*) NULL;

#define OUTPUT_BUFFER_SIZE 1024

/*!
 * MyDialog constructors
 */

OSCWindow::OSCWindow( )
: wxFrame(NULL,wxID_ANY,wxT("OSCSurface"),wxDefaultPosition, wxSize(500,500))
{
	prefDialog = NULL;

	wxMenu *fileMenu = new wxMenu();
    fileMenu->Append (wxID_OPEN, _("&Open ..\tCtrl+O"));
    fileMenu->Append (wxID_SAVE, _("&Save\tCtrl+S"));
    fileMenu->Append (wxID_SAVEAS, _("Save &as ..\tCtrl+Shift+S"));
    fileMenu->Append (wxID_CLOSE, _("&Close\tCtrl+W"));
    fileMenu->AppendSeparator();
    /*fileMenu->Append (myID_PROPERTIES, _("Proper&ties ..\tCtrl+I"));
    fileMenu->AppendSeparator();*/
    fileMenu->Append (wxID_PRINT_SETUP, _("Print Set&up .."));
    fileMenu->Append (wxID_PREVIEW, _("Print Pre&view\tCtrl+Shift+P"));
    fileMenu->Append (wxID_PRINT, _("&Print ..\tCtrl+P"));
    fileMenu->AppendSeparator();
	fileMenu->Append(wxID_PREFERENCES, wxT("Preferences..."),wxT("Change the Settings"));
	fileMenu->AppendSeparator();
	fileMenu->Append(wxID_EXIT, wxT("E&xit\tAlt-X"),wxT("Quit this program"));
	wxMenu *helpMenu = new wxMenu;

	helpMenu->Append(wxID_ABOUT, wxT("&About...\tF1"),wxT("Show About Dialog"));

    wxMenu *menuEdit = new wxMenu;
    menuEdit->Append (wxID_UNDO, _("&Undo\tCtrl+Z"));
    menuEdit->Append (wxID_REDO, _("&Redo\tCtrl+Shift+Z"));
    menuEdit->AppendSeparator();
    menuEdit->Append (wxID_CUT, _("Cu&t\tCtrl+X"));
    menuEdit->Append (wxID_COPY, _("&Copy\tCtrl+C"));
    menuEdit->Append (wxID_PASTE, _("&Paste\tCtrl+V"));
    menuEdit->Append (wxID_CLEAR, _("&Delete\tDel"));
    menuEdit->AppendSeparator();
    menuEdit->Append (wxID_FIND, _("&Find\tCtrl+F"));
    menuEdit->Enable (wxID_FIND, false);
    menuEdit->Append (myID_FINDNEXT, _("Find &next\tF3"));
    menuEdit->Enable (myID_FINDNEXT, false);
    menuEdit->Append (myID_REPLACE, _("&Replace\tCtrl+H"));
    menuEdit->Enable (myID_REPLACE, false);
    menuEdit->Append (myID_REPLACENEXT, _("Replace &again\tShift+F4"));
    menuEdit->Enable (myID_REPLACENEXT, false);
    menuEdit->AppendSeparator();
    menuEdit->Append (myID_BRACEMATCH, _("&Match brace\tCtrl+M"));
    menuEdit->Append (myID_GOTO, _("&Goto\tCtrl+G"));
    menuEdit->Enable (myID_GOTO, false);
    menuEdit->AppendSeparator();
    menuEdit->Append (myID_INDENTINC, _("&Indent increase\tTab"));
    menuEdit->Append (myID_INDENTRED, _("I&ndent reduce\tBksp"));
    menuEdit->AppendSeparator();
    menuEdit->Append (wxID_SELECTALL, _("&Select all\tCtrl+A"));
    menuEdit->Append (myID_SELECTLINE, _("Select &line\tCtrl+L"));

    // charset submenu
    wxMenu *menuCharset = new wxMenu;
    menuCharset->Append (myID_CHARSETANSI, _("&ANSI (Windows)"));
    menuCharset->Append (myID_CHARSETMAC, _("&MAC (Macintosh)"));

    // View menu
    wxMenu *menuView = new wxMenu;
    /*menuView->Append (myID_HILIGHTLANG, _("&Hilight language .."), menuHilight);
    menuView->AppendSeparator();*/
    menuView->AppendCheckItem (myID_FOLDTOGGLE, _("&Toggle current fold\tCtrl+T"));
    menuView->AppendCheckItem (myID_OVERTYPE, _("&Overwrite mode\tIns"));
    menuView->AppendCheckItem (myID_WRAPMODEON, _("&Wrap mode\tCtrl+U"));
    menuView->AppendSeparator();
    menuView->AppendCheckItem (myID_DISPLAYEOL, _("Show line &endings"));
    menuView->AppendCheckItem (myID_INDENTGUIDE, _("Show &indent guides"));
    menuView->AppendCheckItem (myID_LINENUMBER, _("Show line &numbers"));
    menuView->AppendCheckItem (myID_LONGLINEON, _("Show &long line marker"));
    menuView->AppendCheckItem (myID_WHITESPACE, _("Show white&space"));
    menuView->AppendSeparator();
    menuView->Append (myID_USECHARSET, _("Use &code page of .."), menuCharset);

    // change case submenu
    wxMenu *menuChangeCase = new wxMenu;
    menuChangeCase->Append (myID_CHANGEUPPER, _("&Upper case"));
    menuChangeCase->Append (myID_CHANGELOWER, _("&Lower case"));

    // convert EOL submenu
    wxMenu *menuConvertEOL = new wxMenu;
    menuConvertEOL->Append (myID_CONVERTCR, _("CR (&Linux)"));
    menuConvertEOL->Append (myID_CONVERTCRLF, _("CR+LF (&Windows)"));
    menuConvertEOL->Append (myID_CONVERTLF, _("LF (&Macintosh)"));

    // Extra menu
    wxMenu *menuExtra = new wxMenu;
    menuExtra->AppendCheckItem (myID_READONLY, _("&Readonly mode"));
    menuExtra->AppendSeparator();
    menuExtra->Append (myID_CHANGECASE, _("Change &case to .."), menuChangeCase);
    menuExtra->AppendSeparator();
    menuExtra->Append (myID_CONVERTEOL, _("Convert line &endings to .."), menuConvertEOL);

    // Window menu
    wxMenu *menuWindow = new wxMenu;
    menuWindow->Append (myID_PAGEPREV, _("&Previous\tCtrl+Shift+Tab"));
    menuWindow->Append (myID_PAGENEXT, _("&Next\tCtrl+Tab"));

	wxMenuBar *menuBar = new wxMenuBar();
	menuBar->Append(fileMenu, wxT("&File"));
    menuBar->Append (menuEdit, _("&Edit"));
    menuBar->Append (menuView, _("&View"));
    menuBar->Append (menuExtra, _("E&xtra"));
    menuBar->Append (menuWindow, _("&Window"));
	menuBar->Append(helpMenu, wxT("&Help"));

	SetMenuBar(menuBar);

	CreateStatusBar(2);
	SetStatusText(wxT("Welcome to OSC surface!"));

	createControls();
	
	if(!SETTING_GET(OSCWindow,last_chuck_file).IsEmpty())
		FileOpen(SETTING_GET(OSCWindow,last_chuck_file));
}

void OSCWindow::createControl(wxPanel* panel, wxFlexGridSizer *gridSizer, ctrl_type type, wxString name, int nr)
{
	switch(type)
	{
	case OSCBUTTON:
		{
			wxButton *b1 = new wxButton(panel, ID_BUTTON1+nr, name);
			gridSizer->Add(b1, 0, wxALIGN_LEFT | wxALL, 5);
		}
		break;
	case OSCSLIDER:
		{
			wxFlexGridSizer *subsizer = new wxFlexGridSizer(2,1,0,0);
			wxStaticText *st = new wxStaticText(panel, wxID_ANY, name);
			subsizer->Add(st, 0, wxALIGN_LEFT | wxALL, 5);
			wxSlider *sl = new wxSlider(panel, ID_SLIDER1+nr, 0,0,1000,wxDefaultPosition,wxSize(200,-1), wxSL_HORIZONTAL);
			subsizer->Add(sl, 0, wxALIGN_LEFT | wxALL, 5);
			subsizer->Fit(panel);
			subsizer->SetSizeHints(panel);			
			gridSizer->Add(subsizer);
		}
		break;
	case OSCTOGGLE:
		{
			wxToggleButton *b1 = new wxToggleButton(panel, ID_TOGGLE1+nr, name);
			gridSizer->Add(b1, 0, wxALIGN_LEFT | wxALL, 5);
		}
		break;
	case OSCXYPAD:
		{
			wxFlexGridSizer *subsizer = new wxFlexGridSizer(2,1,0,0);
			wxStaticText *st = new wxStaticText(panel, wxID_ANY, name);
			subsizer->Add(st, 0, wxALIGN_LEFT | wxALL, 5);
			XYPadControl *xy = new XYPadControl(panel, ID_XYPAD1+nr, wxDefaultPosition,wxSize(200,200));
			subsizer->Add(xy, 0, wxALIGN_LEFT | wxALL, 5);
			subsizer->Fit(panel);
			subsizer->SetSizeHints(panel);			
			gridSizer->Add(subsizer);
		}
		break;
	}
}

void OSCWindow::OnCloseControl(wxCommandEvent& event)
{
    notebook->DeletePage(notebook->GetSelection());
}

#define NOSTRING 0
#define SINGLEQUOTE 1
#define DOUBLEQUOTE 2
#define NOCOMMENT 0
#define ISCOMMENT 2
void OSCWindow::parseFileContent(wxString fileContent, wxPanel *panel)
{
    wxArrayString comments;
    wxString commline;
    wxString commlines;
    int commenton = 0;
    int stringon = 0;
    bool escapeon = false;

	// extract comments
	for(size_t i = 0; i < fileContent.Len(); i++)
	{
		if(escapeon)
		{
			escapeon = false;
		}
		else
		{
			switch(fileContent[i])
			{
				case '\r' :
				case '\n' :
					if(commenton == ISCOMMENT)
					{
						commline = commline.Strip(wxString::both);
						//::wxMessageBox(commline);
						if(commline.StartsWith("@",&commline))
						{
							commline = commline.Strip(wxString::both);							
							comments.Add(commline);
						}
					}
					commenton = NOCOMMENT;
					commline = "";
					break;
				case '/' :
					if(stringon == NOSTRING)				
						commenton++;
					break;
				case '\"' :
					if(commenton == ISCOMMENT)
					{
						commline += fileContent[i];
						break;
					}
					if((stringon == NOSTRING) && (commenton != ISCOMMENT))
						stringon = DOUBLEQUOTE;
					else if((stringon == DOUBLEQUOTE) && (commenton != ISCOMMENT))
					{
						stringon = NOSTRING;
					}
					break;
				case '\'' :
					if(commenton == ISCOMMENT)
					{
						commline += fileContent[i];
						break;
					}
					if((stringon == NOSTRING) && (commenton != ISCOMMENT))
						stringon = SINGLEQUOTE;
					else if((stringon == SINGLEQUOTE) && (commenton != ISCOMMENT))
					{
						stringon = NOSTRING;
					}
					break;
				case '\\' :
					if(commenton == ISCOMMENT)
					{
						commline += fileContent[i];
						break;
					}
					escapeon = true;
					break;
				default:
					if(commenton == ISCOMMENT)
						commline += fileContent[i];
					else
						commenton = NOCOMMENT;
					break;
			}
		}
	}
	
	int ctrl_num = comments.Count();
	int col = (int)(sqrt((float)ctrl_num));
	int row = col*col < ctrl_num ? col+1 : col;
	int slidernum = 0;
	int buttonnum = 0;
	int xypadnum = 0;
	int togglenum = 0;

	wxFlexGridSizer *gridSizer = new wxFlexGridSizer(col,row,0,0);

	for(int i = 0; i < col; i++)
		gridSizer->AddGrowableCol(i);
	for(int i = 0; i < row; i++)
		gridSizer->AddGrowableRow(i);

	panel->SetSizer(gridSizer);	
    
    wxString line;
    wxString ctrlname;
    for(int i = 0; i < comments.Count(); i++)
    {
		line = comments[i];
    	if(line.StartsWith("slider",&line))
    	{
			line = line.Strip(wxString::both);
			if(line.StartsWith("\"",&line))
			{
				ctrlname = line.BeforeFirst('\"');
				line = line.AfterFirst('\"');
			}
			createControl(panel,gridSizer,OSCSLIDER,ctrlname,slidernum++);
		}
		else if(line.StartsWith("xypad",&line))
    	{
			line = line.Strip(wxString::both);
			if(line.StartsWith("\"",&line))
			{
				ctrlname = line.BeforeFirst('\"');
				line = line.AfterFirst('\"');
			}
			createControl(panel,gridSizer,OSCXYPAD,ctrlname,xypadnum++);
		}
		else if(line.StartsWith("button",&line))
    	{
			line = line.Strip(wxString::both);
			if(line.StartsWith("\"",&line))
			{
				ctrlname = line.BeforeFirst('\"');
				line = line.AfterFirst('\"');
			}
			createControl(panel,gridSizer,OSCBUTTON,ctrlname,buttonnum++);
		}
		else if(line.StartsWith("toggle",&line))
    	{
			line = line.Strip(wxString::both);
			if(line.StartsWith("\"",&line))
			{
				ctrlname = line.BeforeFirst('\"');
				line = line.AfterFirst('\"');
			}
			createControl(panel,gridSizer,OSCTOGGLE,ctrlname,togglenum++);
		}
	}

	gridSizer->Fit(panel);
	gridSizer->SetSizeHints(panel);  
}

void OSCWindow::createControllerTabs(wxString fname, wxString fileContent)
{
	wxPanel *w1 = new wxPanel(notebook, wxID_ANY);

	notebook->AddPage(w1, wxString("ctrl \"")+fname+"\"", true);

	wxFlexGridSizer *gridSizerW = new wxFlexGridSizer(2,1,0,0);
	gridSizerW->AddGrowableCol(0);
	gridSizerW->AddGrowableRow(1);
	w1->SetSizer(gridSizerW);

    wxButton *cls = new wxButton(w1, ID_CLOSE_CONTROL, "Close", wxDefaultPosition,wxDefaultSize,wxNO_BORDER | wxBU_EXACTFIT,wxDefaultValidator,wxString("closebutton ")+fname);
    gridSizerW->Add(cls);

	wxPanel *panel = new wxPanel(w1, wxID_ANY); 
	gridSizerW->Add(panel, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL | wxEXPAND , 0);

    parseFileContent(fileContent, panel);

	gridSizerW->Fit(w1);
	gridSizerW->SetSizeHints(w1);

	topsizer->Fit(this);
	topsizer->SetSizeHints(this);
}

void OSCWindow::createEditTab()
{
	wxPanel *w2 = new wxPanel(notebook, wxID_ANY);

	notebook->AddPage(w2, wxT("edit"), false);

	wxFlexGridSizer *fgs = new wxFlexGridSizer(2,1,0,0);
	w2->SetSizer(fgs);
	fgs->AddGrowableCol(0);
	fgs->AddGrowableRow(1);

	wxFlexGridSizer *gridSizerW = new wxFlexGridSizer(1,2,0,0);
	fgs->Add(gridSizerW);

	chuckFileName = new wxTextCtrl(w2,ID_CHUCK_FILE,SETTING_GET(OSCWindow,last_chuck_file),wxDefaultPosition,wxSize(350,20));
	gridSizerW->Add(chuckFileName, 0, wxALIGN_LEFT | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	wxButton *chuckB = new wxButton(w2, ID_CHUCK_EXEC, "exec chuck");
	gridSizerW->Add(chuckB, 0, wxALIGN_LEFT | wxALIGN_CENTER_VERTICAL | wxALL, 5);

	m_edit = new Edit(w2, wxID_ANY, wxDefaultPosition, wxSize(600,400));
	fgs->Add(m_edit, 0, wxALIGN_LEFT | wxALIGN_CENTER_VERTICAL | wxALL | wxEXPAND, 5);

	fgs->Fit(w2);
	fgs->SetSizeHints(w2);

	topsizer->Fit(this);
	topsizer->SetSizeHints(this);
}

void OSCWindow::createControls()
{
	topsizer = new wxFlexGridSizer(2,1,0,0);
	topsizer->AddGrowableCol(0);
	topsizer->AddGrowableRow(0);
	topsizer->AddGrowableRow(1);

	notebook = new wxNotebook(this, wxID_ANY);
	topsizer->Add(notebook, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL | wxEXPAND, 0);

	createEditTab();

	topsizer->Fit(this);
	topsizer->SetSizeHints(this);
}

void OSCWindow::OnClose (wxCloseEvent &event) 
{
    wxCommandEvent evt;
    OnFileClose (evt);
    if (m_edit && m_edit->Modified()) {
        if (event.CanVeto()) event.Veto (true);
        return;
    }
    Destroy();
}

// properties event handlers
void OSCWindow::OnProperties (wxCommandEvent &WXUNUSED(event)) {
    //if (!m_edit) return;
    //EditProperties dlg(m_edit, 0);
}

void OSCWindow::FileOpen(wxString fname)
{
    wxFileName w(fname); w.Normalize(); fname = w.GetFullPath();
    m_edit->LoadFile (fname);
}

// file event handlers
void OSCWindow::OnFileOpen (wxCommandEvent &WXUNUSED(event)) 
{
    if (!m_edit) return;
#if wxUSE_FILEDLG
    wxString fname;
    wxFileDialog dlg (this, _T("Open file"), wxEmptyString, wxEmptyString, _T("Any file (*)|*"),
                      wxOPEN | wxFILE_MUST_EXIST | wxCHANGE_DIR);
    if (dlg.ShowModal() != wxID_OK) return;
    fname = dlg.GetPath ();
    FileOpen (fname);
    chuckFileName->SetValue(m_edit->GetFilename());
#endif // wxUSE_FILEDLG
}

void OSCWindow::OnFileSave (wxCommandEvent &WXUNUSED(event)) 
{
    if(!m_edit) return;

    if(m_edit->Modified())
	    m_edit->SaveFile();
}

void OSCWindow::OnFileSaveAs (wxCommandEvent &WXUNUSED(event)) 
{
    if(!m_edit) return;
#if wxUSE_FILEDLG
    wxString filename = wxEmptyString;
    wxFileDialog dlg(this, _T("Save file"), wxEmptyString, wxEmptyString, _T("Any file (*)|*"), wxSAVE|wxOVERWRITE_PROMPT);
    if (dlg.ShowModal() != wxID_OK) 
		return;
    filename = dlg.GetPath();
    m_edit->SaveFile(filename);
#endif // wxUSE_FILEDLG
}

void OSCWindow::OnFileClose (wxCommandEvent &WXUNUSED(event)) 
{
    if (!m_edit) return;
    if (m_edit->Modified()) {
        if (wxMessageBox (_("Text is not saved, save before closing?"), _("Close"),
                          wxYES_NO | wxICON_QUESTION) == wxYES) {
            m_edit->SaveFile();
            if (m_edit->Modified()) {
                wxMessageBox (_("Text could not be saved!"), _("Close abort"),
                              wxOK | wxICON_EXCLAMATION);
                return;
            }
        }
    }
    m_edit->SetFilename (wxEmptyString);
    m_edit->ClearAll();
    m_edit->SetSavePoint();
}

// print event handlers
void OSCWindow::OnPrintSetup (wxCommandEvent &WXUNUSED(event)) 
{
#if wxUSE_PRINTING_ARCHITECTURE
    (*g_pageSetupData) = * g_printData;
    wxPageSetupDialog pageSetupDialog(this, g_pageSetupData);
    pageSetupDialog.ShowModal();
    (*g_printData) = pageSetupDialog.GetPageSetupData().GetPrintData();
    (*g_pageSetupData) = pageSetupDialog.GetPageSetupData();
#endif // wxUSE_PRINTING_ARCHITECTURE
}

void OSCWindow::OnPrintPreview (wxCommandEvent &WXUNUSED(event)) {
#if wxUSE_PRINTING_ARCHITECTURE
    wxPrintDialogData printDialogData( *g_printData);
    wxPrintPreview *preview =
        new wxPrintPreview (new EditPrint (m_edit),
                            new EditPrint (m_edit),
                            &printDialogData);
    if (!preview->Ok()) {
        delete preview;
        wxMessageBox (_("There was a problem with previewing.\n\
                         Perhaps your current printer is not correctly?"),
                      _("Previewing"), wxOK);
        return;
    }
    wxRect rect = DeterminePrintSize();
    wxPreviewFrame *frame = new wxPreviewFrame (preview, this, _("Print Preview"));
    frame->SetSize (rect);
    frame->Centre(wxBOTH);
    frame->Initialize();
    frame->Show(true);
#endif // wxUSE_PRINTING_ARCHITECTURE
}

void OSCWindow::OnPrint (wxCommandEvent &WXUNUSED(event)) {
#if wxUSE_PRINTING_ARCHITECTURE
    wxPrintDialogData printDialogData( *g_printData);
    wxPrinter printer (&printDialogData);
    EditPrint printout (m_edit);
    if (!printer.Print (this, &printout, true)) {
        if (wxPrinter::GetLastError() == wxPRINTER_ERROR) {
        wxMessageBox (_("There was a problem with printing.\n\
                         Perhaps your current printer is not correctly?"),
                      _("Previewing"), wxOK);
            return;
        }
    }
    (*g_printData) = printer.GetPrintDialogData().GetPrintData();
#endif // wxUSE_PRINTING_ARCHITECTURE
}

// edit events
void OSCWindow::OnEdit (wxCommandEvent &event) 
{
    if (m_edit) m_edit->ProcessEvent (event);
}

void OSCWindow::OnQuit(wxCommandEvent& event)
{
	Close();
}

void OSCWindow::sendValue(int ctrlnum, float val1, float val2)
{
    UdpTransmitSocket transmitSocket(IpEndpointName(SETTING_GET(OSCWindow,osc_adress), SETTING_GET(OSCWindow,osc_port)));
    
    char buffer[OUTPUT_BUFFER_SIZE];
    osc::OutboundPacketStream p( buffer, OUTPUT_BUFFER_SIZE );
    
    p << osc::BeginBundleImmediate << osc::BeginMessage( "/val" ) << ctrlnum-ID_CONTROLROOT << (float)val1 << (float)val2 << osc::EndMessage << osc::EndBundle;
	wxString msg = wxString::Format("OSC message: /val %d,%f,%f",ctrlnum-ID_CONTROLROOT,val1,val2);

	//msglabel->SetLabel(msg);
	SetStatusText(msg);
    
    transmitSocket.Send(p.Data(), p.Size());
}

void OSCWindow::OnAbout(wxCommandEvent& event)
{
	wxString msg = wxT("a very simple\nOSCSurface 0.1alpha\nby Jrg Piringer 2006\nhttp://joerg.piringer.net");

	wxMessageBox(msg, wxT("About OSCSurface"), wxOK | wxICON_INFORMATION, this);

}

void OSCWindow::OnPreferences(wxCommandEvent& event)
{
	if(prefDialog == NULL)
		prefDialog = new PreferencesDialog(NULL,ID_PREFERENCES,_T("Preferences"),wxDefaultPosition,wxSize(500,400));
	prefDialog->ShowModal();
	prefDialog->Destroy();
	delete prefDialog;
	prefDialog = NULL;
	event.Skip();	
}

void OSCWindow::OnExecChuck(wxCommandEvent& event)
{
	wxFileName fn(SETTING_GET(OSCWindow,chuck_path));
	wxFileName ck(chuckFileName->GetValue());

	fn.AppendDir("bin");
	fn.SetName("chuck");

	last_chuck_file = ck.GetFullPath();

	::wxExecute(fn.GetFullPath()+wxT(" \"")+chuckFileName->GetValue()+wxT(" \""));

	createControllerTabs(ck.GetFullName(),m_edit->GetText());
}

void OSCWindow::OnSlider(wxCommandEvent& event)
{
	sendValue(event.GetId(),((float)((wxSlider *)event.GetEventObject())->GetValue())/1000);
}

void OSCWindow::OnButton(wxCommandEvent& event)
{
	sendValue(event.GetId(),1);
}

void OSCWindow::OnToggle(wxCommandEvent& event)
{
	sendValue(event.GetId(),((float)((wxToggleButton *)event.GetEventObject())->GetValue()));
}

void OSCWindow::OnXYPad(XYPadEvent& event)
{
	sendValue(event.GetId(),event.GetX(),event.GetY());
}


/*!
 * Should we show tooltips?
 */

bool OSCWindow::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap OSCWindow::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval

    wxUnusedVar(name);
    return wxNullBitmap;
}

/*!
 * Get icon resources
 */

wxIcon OSCWindow::GetIconResource( const wxString& name )
{
    // Icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
}

wxRect OSCWindow::DeterminePrintSize() 
{

    wxSize scr = wxGetDisplaySize();

    // determine position and size (shifting 16 left and down)
    wxRect rect = GetRect();
    rect.x += 16;
    rect.y += 16;
    rect.width = wxMin (rect.width, (scr.x - rect.x));
    rect.height = wxMin (rect.height, (scr.x - rect.y));

    return rect;
}
