/////////////////////////////////////////////////////////////////////////////
// Name:        PreferencesDialog.cpp
// Purpose:     
// Author:      Jrg Piringer
// Modified by: 
// Created:     11/29/05 15:58:13
// RCS-ID:      
// Copyright:   
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////


#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "PreferencesDialog.h"
#endif

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#pragma warning(push)
#pragma warning(disable : 4996)

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif


#include "PreferencesDialog.h"
#include <wx/listbook.h>
#include <wx/propgrid/propgrid.h>
#pragma warning(pop)

#include "bitmaps/setgeneral.xpm"
#include "bitmaps/setaudiomidi.xpm"
#include "bitmaps/fp.xpm"


/*!
 * PreferencesDialog type definition
 */

IMPLEMENT_DYNAMIC_CLASS( PreferencesDialog, wxDialog )

/*!
 * PreferencesDialog event table definition
 */

BEGIN_EVENT_TABLE( PreferencesDialog, wxDialog )
    EVT_BUTTON(wxID_OK, PreferencesDialog::OnBnClickedOk)
END_EVENT_TABLE()

/*!
 * PreferencesDialog constructors
 */

PreferencesDialog::PreferencesDialog( )
{
}

PreferencesDialog::PreferencesDialog( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Create(parent, id, caption, pos, size, style);
}

/*!
 * PreferencesDialog creator
 */

bool PreferencesDialog::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    SetExtraStyle(GetExtraStyle()|wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    Centre();
    return true;
}

/*!
 * Control creation for PreferencesDialog
 */

void PreferencesDialog::CreateControls()
{    
    wxBitmap *bitmaps[__LASTSETBITMAP];

    bitmaps[SETGENERAL] = new wxBitmap(setgeneral_xpm);
    bitmaps[SETAUDIOMIDI] = new wxBitmap(setaudiomidi_xpm);
    bitmaps[SETFP] = new wxBitmap(fp_xpm);

    PreferencesDialog* itemDialog1 = this;

    wxFlexGridSizer* itemFlexGridSizer = new wxFlexGridSizer(2, 1, 0, 0);
    itemFlexGridSizer->AddGrowableRow(0);
    itemFlexGridSizer->AddGrowableCol(0);
    itemDialog1->SetSizer(itemFlexGridSizer);

    propGridManager = new wxPropertyGridManager(itemDialog1, ID_NOTEBOOK, wxDefaultPosition, wxDefaultSize, wxPG_TOOLBAR | wxPG_DEFAULT_STYLE | wxPG_BOLD_MODIFIED | wxPG_TOOLTIPS); 

	Settings::populateProperties(propGridManager,bitmaps);

    itemFlexGridSizer->Add(propGridManager, 0, wxGROW|wxGROW|wxALL, 5);

    wxFlexGridSizer* itemFlexGridSizer2 = new wxFlexGridSizer(1, 2, 0, 0);
    itemFlexGridSizer2->AddGrowableCol(0);
    itemFlexGridSizer2->AddGrowableCol(1);
    itemFlexGridSizer->Add(itemFlexGridSizer2, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton1 = new wxButton( itemDialog1, wxID_OK, _("&OK"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer2->Add(itemButton1, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton2 = new wxButton( itemDialog1, wxID_CANCEL, _("&Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer2->Add(itemButton2, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 5);
}

/*!
 * Should we show tooltips?
 */

bool PreferencesDialog::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap PreferencesDialog::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
}

/*!
 * Get icon resources
 */

wxIcon PreferencesDialog::GetIconResource( const wxString& name )
{
    // Icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
}

void PreferencesDialog::OnBnClickedOk(wxCommandEvent &event)
{
	Settings::storeProperties(propGridManager);
	OnOK(event);
}

