/////////////////////////////////////////////////////////////////////////////
// Name:        PreferencesDialog.h
// Purpose:     
// Author:      Jrg Piringer
// Modified by: 
// Created:     11/29/05 15:58:13
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _PREFERENCESDIALOG_H_
#define _PREFERENCESDIALOG_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "PreferencesDialog.cpp"
#endif

/*!
 * Includes
 */

#include "wx/notebook.h"
#include "wx/listctrl.h"
#include "wx/tglbtn.h"

#include "Settings.h"

/*!
 * Forward declarations
 */

/*!
 * Control identifiers
 */

#define ID_PREFERENCES 10004
#define SYMBOL_PREFERENCESDIALOG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_PREFERENCESDIALOG_TITLE _("Preferences")
#define SYMBOL_PREFERENCESDIALOG_IDNAME ID_PREFERENCES
#define SYMBOL_PREFERENCESDIALOG_SIZE wxSize(600, 500)
#define SYMBOL_PREFERENCESDIALOG_POSITION wxDefaultPosition
#define ID_NOTEBOOK 10005
#define ID_TABGENERAL 10006
#define ID_LISTCTRL1 10024
#define ID_TABAUDIOMIDI 10007
#define ID_TOGGLEBUTTON 10031
#define ID_CHECKBOX1 10038
#define ID_CHECKLISTBOX 10039
#define ID_TABFP 10008

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif

/*!
 * PreferencesDialog class declaration
 */

class PreferencesDialog: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( PreferencesDialog )
    DECLARE_EVENT_TABLE()

	wxPropertyGridManager *propGridManager;
public:
    /// Constructors
    PreferencesDialog( );
    PreferencesDialog( wxWindow* parent, wxWindowID id = SYMBOL_PREFERENCESDIALOG_IDNAME, const wxString& caption = SYMBOL_PREFERENCESDIALOG_TITLE, const wxPoint& pos = SYMBOL_PREFERENCESDIALOG_POSITION, const wxSize& size = SYMBOL_PREFERENCESDIALOG_SIZE, long style = SYMBOL_PREFERENCESDIALOG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_PREFERENCESDIALOG_IDNAME, const wxString& caption = SYMBOL_PREFERENCESDIALOG_TITLE, const wxPoint& pos = SYMBOL_PREFERENCESDIALOG_POSITION, const wxSize& size = SYMBOL_PREFERENCESDIALOG_SIZE, long style = SYMBOL_PREFERENCESDIALOG_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );

    /// Should we show tooltips?
    static bool ShowToolTips();

	void OnBnClickedOk(wxCommandEvent &event);

};

#endif
    // _PREFERENCESDIALOG_H_
