// OSCSurface example
// by jrg piringer
// 2006

// begin surface definition
// @toggle "start here"
// @button "randomize"
// @slider "volume" 
// @xypad "frequency xypad" 
// end surface definition

// the patch
sinosc m => sinosc o => dac;
440 => o.freq;
2 => o.sync;
1 => m.freq;
200 => m.gain;

// create our OSC receiver
OscRecv recv;
7000 => recv.port;
recv.listen();
// create an address in the receiver, store in new variable
recv.event( "/val","iff" ) @=> OscEvent oe1;

<<< "listening..." >>>;

int id;
float flt;
float fl2;
1 => float volume;
0 => int soundon;
0 => o.gain;

// infinite event loop
while(true)
{
    // poll every 20 ms
    10::ms => now;
    
    if(oe1.nextMsg() != 0)
    { 
    	oe1.getInt() => id;
        oe1.getFloat() => flt;
        oe1.getFloat() => fl2;

        <<<  "msg:", id, flt, fl2 >>>;
	
        if(id == 0) // button
        {
            std.rand2f(440,1440) => o.freq;
            std.rand2f(0,200) => m.freq;
        } 
        else if(id == 100) // slider
        {
            flt => volume;
            if(soundon == 1)
                volume => o.gain;
        }
        else if(id == 200) // toggle
        {
            if(flt == 1.0)
            {
                volume => o.gain;
                1 => soundon;
            }
            else
            { 
                0 => o.gain;
                0 => soundon;
            }
        }
        else if(id == 300) // xypad
        {
            440+flt*1000 => o.freq;
            fl2*200 => m.freq;
        } 
    }
}
